//+------------------------------------------------------------------+
//|                                                Breakout bars     |
//|           (C) 2008 mikkom, contact: mikko.mattila@kirkas.com     |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "mikkom"

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1  Red
#property indicator_color2  Green
#property indicator_color3  Red
#property indicator_color4  Green
#property indicator_width1  1
#property indicator_width2  1
#property indicator_width3  3
#property indicator_width4  3

//
//
//
//
//

extern int    timeFrame       = 0;
extern int    count           = 20;
extern string note            = "turn on Alert = true; turn off = false";
extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = false;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = true;
extern bool   alertsEmail     = false;
extern string soundfile       = "alert2.wav";

//
//
//
//
//

double red[];
double green[];
double redBody[];
double greenBody[];
double trend[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init() 
{

   IndicatorBuffers(5);
   SetIndexBuffer(0,red);       SetIndexStyle(0,DRAW_HISTOGRAM); 
   SetIndexBuffer(1,green);     SetIndexStyle(1,DRAW_HISTOGRAM);     
   SetIndexBuffer(2,redBody);   SetIndexStyle(2,DRAW_HISTOGRAM);     
   SetIndexBuffer(3,greenBody); SetIndexStyle(3,DRAW_HISTOGRAM);  
   SetIndexBuffer(4,trend);   
   IndicatorShortName("Mikko breakout bars "); 
   return(0);
}
  
int deinit() { return(0); }

//
//
//
//
//

int start()
{
   int counted_bars  = IndicatorCounted(); 
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
          int limit=MathMax(Bars-counted_bars,3*timeFrame/Period());
   

   //
   //
   //
   //
   //
   
   for (int i = limit; i >= 0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
      double mmLow  =  iLow(NULL,timeFrame, iLowest(NULL,timeFrame,MODE_LOW, count,y+1));
      double mmHigh = iHigh(NULL,timeFrame,iHighest(NULL,timeFrame,MODE_HIGH,count,y+1));
      
      trend[i] = 0;
      if (High[i] > mmHigh) trend[i] = 1;
      if (Low[i]  < mmLow)  trend[i] =-1;
      
      //
      //
      //
      //
      //
      
      green[i]     = EMPTY_VALUE;
      red[i]       = EMPTY_VALUE;
      greenBody[i] = EMPTY_VALUE;
      redBody[i]   = EMPTY_VALUE;
      if (trend[i] !=trend[i+1])
      {
        if (trend[i]== 1)
        {
           green[i]     = High[i];      
           red[i]       = Low[i];  
           greenBody[i] = MathMax(Open[i], Close[i]);      
           redBody[i]   = MathMin(Open[i], Close[i]);
        }
        if (trend[i]==-1)
        {
           red[i]       = High[i];      
           green[i]     = Low[i];  
           redBody[i]   = MathMax(Open[i], Close[i]);      
           greenBody[i] = MathMin(Open[i], Close[i]);
        }
      }
   } 
   
   //
   //
   //
   //
   //
      
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
      if (trend[whichBar] != trend[whichBar+1])
      if (trend[whichBar] == 1)
            doAlert("up candle");
      else  doAlert("down candle");       
   }
return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," - ",timeFrame+" mikko_breakout_bar ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," mikko_breakout_bar "),message);
             if (alertsSound)   PlaySound(soundfile);
      }
}
         